unit dlltestmainu;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, EditBtn, StdCtrls,
  Buttons, JSONPropStorage;

type
  TConvertCallBack = procedure(aLine : PChar);
  TConvert = procedure(aFilename : PChar; aCallback : TConvertCallback);
  TConvertFileCallback = procedure(var x1, y1, z1, x2, y2, z2, x3, y3, z3 : Double);
  TConvertFile = procedure(aFilename : PChar; aCallback : TConvertFileCallback);
  TOnNewFace = procedure (var fId : integer; FaceType : PChar);
  TOnFaceDone = procedure;
  TCallback2 = procedure (var fId, plId : integer; var x, y, z : Double; var edge : PChar);
  TAddrCallback = procedure(var addr, prjId : PChar);
  TConvert2 = procedure (fName : PChar; cbNewFace : TOnNewFace; cbFaceDone : TOnFaceDone; cb : TCallBack2; addrcb : TAddrCallback);
  PConvert2 = ^TConvert2;

  { TForm1 }

  TForm1 = class(TForm)
    btnJSon2: TBitBtn;
    btnText: TBitBtn;
    btnJSon: TBitBtn;
    edFilename: TFileNameEdit;
    JSONPropStorage1: TJSONPropStorage;
    Label1: TLabel;
    Memo1: TMemo;
    procedure btnTextClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  LastfId, LastPLId : integer;

implementation

{$R *.lfm}

procedure Callback(aLine : PChar);
begin
  Form1.Memo1.Lines.Add(aLine);
end;

procedure ConvertFileCallback(var x1, y1, z1, x2, y2, z2, x3, y3, z3 : Double);
var s : string;
function Fo(ax, ay, az : Double) : string;
  begin
    Result := Format('(%.3f, %.3f, %.3f)', [ax, ay, az]);
  end;
begin
  s := Fo(x1, y1, z1) + ' ' + Fo(x2, y2, z2) + ' ' + Fo(x3, y3, z3);
  Form1.Memo1.Lines.Add(s);
end;

procedure AddrCallBack(var Addr, PrjId : PChar);
var i : integer;
    str, plz, ort : String;
    line : string;
begin
    str := '';
    plz := '';
    ort := '';
    Line := Addr;
    i := Pos(',', Line);
    if (i > 0) then
    begin
      str := copy(Line, 1, i);
      system.delete(Line, 1, i);
    end;
    i := Pos(',', Line);
    if (i > 0) then
    begin
      ort := Trim(copy(Line, 1, i));
      system.delete(Line, 1, i);
      i := Pos(' ', ort);
      if (i > 0) then
      begin
        plz := copy(ort, 1, i-1);
        system.delete(ort, 1, i);
      end;
    end;
    Form1.Memo1.Lines.Add(plz + ' ' + ort + ', ' + str);
end;

procedure onNewFace(var fId : integer; FaceType : PChar);
var s : string;
begin
  LastfId := fId;
  Form1.Memo1.Lines.Add('Neue Fläche ' + IntToStr(fId) + ' (' + FaceType + ')');
end;

procedure onFaceDone;
begin
  Form1.Memo1.Lines.Add('Face done');
end;

// Die zweite Möglichkeit kann mehrere Polylines enthalten?
procedure Callback2(var fId, plId : integer; var x, y, z : Double; var edge : PChar);
begin
 Assert(LastfId = fId);
 if (LastPLId <> plId) then
 begin
   Form1.Memo1.Lines.Add('Neue Fehlflaeche');
   LastfId := fId;
   LastPLId := plId;
 end;
 Form1.Memo1.Lines.Add(Format('Neuer Punkt: fId: %d, plId: %d, (%.3f, %.3f, %.3f) - %s', [fId, plId, x, y, z, edge]));
end;

{ TForm1 }

procedure TForm1.btnTextClick(Sender: TObject);
var dllHandle : THandle;
    Convert : TConvert;
    ConvertFile : TConvertFile;
    ConvertFile2 : TConvert2;
begin
  if (FileExists(edFilename.Filename)) then
  begin
    dllHandle := LoadLibrary(Application.Location + 'librarytest.dll');
    if (dllHandle <> 0) then
    begin
      LastfId := 0;
      LastPLId := 0;
      Convert := TConvert(GetProcAddress(dllHandle, 'Convert'));
      ConvertFile := TConvertFile(GetProcAddress(dllHandle, 'ConvertFile'));
      ConvertFile2 := TConvert2(GetProcAddress(dllHandle, 'ConvertFile2'));
      Memo1.Clear;
      if Sender = btnText then
        Convert(PChar(edFilename.FileName), @Callback)
      else if Sender = btnJSon then
        ConvertFile(PChar(edFilename.Filename), @ConvertFileCallback)
      else
        ConvertFile2(PChar(edFilename.FileName), @OnNewFace, @OnFaceDone, @Callback2, @AddrCallback);
      FreeLibrary(dllHandle);
    end;
  end;
end;

end.

